/* 
 * From : Sergey I. Yevtushenko, 2:463/114.69 (Friday June 27 1997 07:10)
 * Modified by Dima Maloff 
 * $Id: uptime.c,v 1.1 1997/07/17 02:54:05 mff Exp mff $
 */

#include <sys/types.h>

#define INCL_DOS
#include <os2.h>

time_t get_uptime (void)
{
  static ULONG ulTmrFreq;
  static ULONG ulDelta;

  QWORD qwTmrTime;
  double t = qwTmrTime.ulHi;
  double t1 = qwTmrTime.ulLo;

  if (!ulTmrFreq)
  {
    if (DosTmrQueryFreq (&ulTmrFreq))
    {
      /* Maybe high resolution timer not available, try the old way */
      ULONG ulMsCount;

      if (DosQuerySysInfo (QSV_MS_COUNT, QSV_MS_COUNT,
			   (PVOID) & ulMsCount, sizeof (ULONG)))
	return 0;
      else
	return ulMsCount / 1000;
    }
  }

  if (DosTmrQueryTime (&qwTmrTime))
    return 0;

  t = qwTmrTime.ulHi;
  t1 = qwTmrTime.ulLo;

  t *= (1024 * 1024 * 1024);
  t *= 4;
  t += t1;
  t1 = t / ((double) ulTmrFreq);

  if (!ulDelta)
  {
    ULONG ulMsCount;

    if (DosQuerySysInfo (QSV_MS_COUNT, QSV_MS_COUNT,
			 (PVOID) & ulMsCount, sizeof (ULONG)) == 0)
    {
      /* Uptime counter was not wrapped */
      if (((((unsigned) t1 / 60) / 60) / 24) ==
	  ((((ulMsCount / 1000) / 60) / 60) / 24))
	ulDelta = (ulMsCount / 1000) - ((unsigned) t1);
    }
    /* In case of error, we just ignore it */
  }
  t1 += ulDelta;

  return t1;
  return 0;
}
